procedure DistributionSort(var A: data; n: integer);
  var count: array [datum] of integer;
      i, j, k: integer;
  begin
    (* M = highvalue - lowvalue + 1 *)
    (* Initialize the distribution counts; this takes M steps. *)
    for i := lowvalue to highvalue do count[i] := 0;

    (* Build the distribution counts; this takes n steps. *)
    for i := 1 to n do count[A[i]] := count[A[i]] + 1;

    (* Refill the array; this takes max(n,M) steps. *)
    k := 0;
    for i := lowvalue to highvalue do
      for j := 1 to count[i] do
        begin
          k := k + 1;
          A[k] := i
        end
  end; (* DistributionSort *)
